import java.awt.*;
// import java.awt.event.*;
import java.awt.Color;
import java.awt.Graphics;
import java.util.*;
import java.io.*;

/** This class computs Jacobi Iteration, 
	and paint the matrix by a selected color */
public class jacoGraph extends Canvas implements  Runnable { 
  static  int		IterNum = 10;

  private Thread	thread;	
  private MenuBar	mb;
  private Menu		closeMenu;
  private MenuItem	closeItem;
  private int		rectSize = 16; //small rectangle size
  private int		clrChoice = 0;

  private Graphics gfloor;

  private double [][] colorDat = new double[LENGTH][WIDTH];
  private double [][] colorDatOld = new double[LENGTH][WIDTH];
  //private int [][] colorDat ;

  static int LENGTH = 16,  WIDTH = 16;

  /* static double	Jcolor[][] = new double[LENGTH][WIDTH];
  public static int ColorArray_R[][] = new int[LENGTH][WIDTH];
  public static int ColorArray_G[][] = new int[LENGTH][WIDTH];
  public static int ColorArray_B[][] = new int[LENGTH][WIDTH]; */

  public void start() 
  {
   if(thread == null){
      thread = new Thread(this);
      thread.start();
    }
  }

  /** This method specifies the color flag used in painting */
  public void setClrChoice(int clr)
  {
	this.clrChoice = clr;
	repaint();
  }

  /** This method gets the size of each array element 
	of the metrix in the canvas */
  public int currentRectSize()
  { return this.rectSize;}

  /** This method specifies the size of each array element 
	of the metrix in the canvas */
  public void setRectSize(int newsize)
  {
    this.rectSize = newsize;
	repaint();
  }

  public void stop() {
    if(thread != null){
      thread.stop();
      thread = null;
    }
  } //Override deprecated method

  public void run() {
    while(thread != null){
      repaint();
       try {
         Thread.sleep(100);
       } catch (InterruptedException e) {
        // Do nothing
       };
    }
  }

  /** This method specifies the grid size of the matrix */
  public void setGridSize(int len, int wid)
  { LENGTH = len;		WIDTH = wid; 
	jacoInit();
	repaint();
  }

  /** This method specifies restart the computing and repaint it */
  public void rst(int times)
  {
	// cpArray2(colorDat,colorDatOld,colorDat.length,colorDat[0].length);
    // for (int l = 0; l < times; l++) {
		cpArray2(this.colorDat,this.colorDatOld,LENGTH,WIDTH);
		for(int m = 1; m < LENGTH-1; m++) {
			for(int n = 1; n < WIDTH-1; n++){
				this.colorDat[m][n] = (this.colorDatOld[m+1][n] +
					this.colorDatOld[m-1][n] + this.colorDatOld[m][n+1] + 
					this.colorDatOld[m][n-1]) * 0.25; 
				// System.out.print(this.colorDat[m][n] + " ");
				// repaint(); 
			}
		}
	// }
  }

  /* public static void main(String args[])
  {
	Frame f = new jacoGraph("Jacobi Demo");
	Panel p = new Panel();
	
	p.setLayout(new FlowLayout());
	p.add(new Label("Jacobi Iteration"));
	// p.add(new Button(""));
	f.setLayout(new BorderLayout());
	f.add("North",p);
	// run();
	// f.pack();
	f.resize(600,600);
	f.show();
  } */

  public jacoGraph() // (String s) 
  {    
	// super(s);
	// setLayout(new BorderLayout());
    // MenuBar mb = new MenuBar();
    // Menu closeMenu = new Menu("Close");
    // MenuItem closeItem = new MenuItem("Close");
    // closeMenu.add(closeItem);
    // // closeItem.addActionListener(this);
    // setMenuBar(mb); 
    // mb.add(closeMenu);
	// init();
  }

  // public void actionPerformed(ActionEvent evt) 
  // {  
  //  MenuItem mi = (MenuItem) evt.getSource();
  //  String arg = mi.getLabel();
  //   if(arg.equals("Close"))
  //     setVisible(false);
  // }

  /** This method initialize the array to be computed */
  public void init() 
	{
	  jacoInit();
	}

  /** This method initialize the array to be computed */
  public void jacoInit()
  {
      for (int i = 0; i < LENGTH; i++) 
        for (int j = 0; j < WIDTH; j++) 
            if (i == 0 || i == LENGTH-1 || j == 0 || j == WIDTH-1) {
                this.colorDat[i][j]=1.;
                this.colorDatOld[i][j]=1.;
            } else {
                this.colorDat[i][j]=0.;
                this.colorDatOld[i][j]=0.;
			}
	repaint();
  }

  /** This method computes Jacobi Iteration and paint it */
  public void paint(Graphics g) 
   {
	int x = 10,y = 10;
    // if(Jacobi_h.ColorArray_R != null)
    if(this.colorDat != null)
    for (int i=0; i<LENGTH; i++) {
      for (int j=0; j<WIDTH; j++) {
		switch(this.clrChoice){
			case	0:	
				//System.out.println("color Choice" + this.clrChoice);
				g.setColor(new Color((float) this.colorDat[i][j],(float) 0,(float) 0));
				// g.setColor(new Color(((int) Math.floor(this.colorDat[i][j])),0, 0));
				break;
			case	1:	
				g.setColor(new Color((float) 0,(float) this.colorDat[i][j],(float) 0));
				// g.setColor(new Color(0,((int) Math.floor(this.colorDat[i][j])), 0));
				break;
			case	2:	
				g.setColor(new Color((float) 0, (float) 0,(float) this.colorDat[i][j]));
				// g.setColor(new Color(0, 0,((int) Math.floor(this.colorDat[i][j]))));
				break;
		}
       	g.fillRect(x + i*rectSize, y + j*rectSize,rectSize,rectSize);
      }
    }
   }

  /** This method set up the color array */
  public void setClr(double[][] clrArray)
  {
    this.colorDat = clrArray ;
  }

  public void draw() { 
    repaint();
  }

/*
  private Image offScreenImage;
  private Dimension offScreenSize;
  private Graphics offScreenGraphics;

  public final synchronized void update (Graphics g) {
    Dimension d = getSize();

    if((offScreenImage == null) || (d.width != offScreenSize.width) ||  
       (d.height != offScreenSize.height)) {
      offScreenImage = createImage(d.width, d.height);
      offScreenSize = d;
      offScreenGraphics = offScreenImage.getGraphics();
    }
    offScreenGraphics.clearRect(0, 0, d.width, d.height);
    paint(offScreenGraphics);
    g.drawImage(offScreenImage, 0, 0, null);
  }
 */

  /** This method copy two arrays */
  public void cpArray2(double [][] src, double [][] dst, int len, int wid)
  {
    // System.out.println("len:"+len);
    // System.out.println("wid:"+wid);
    for(int l = 0; l < len; l++) {
      for(int k = 0; k < wid; k++) {
        dst[l][k] = src[l][k];
      }
    }
  }

} 
